<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8">
    <link href="https://brendan.ie/main.css" rel="stylesheet">
    <link href="./event_pointer.css" rel="stylesheet">

    <title>UL Room Finder (Building)</title>

    <meta content="UL Room Finder (Building)" name="title">
    <meta content="Brendan Golden" name="author">
    <meta content="Find free rooms in UL  (Building)" name="description">

    <!-- for mobile devices -->
    <meta content="width=device-width,initial-scale=1" name="viewport">
    <!-- brendan.coffee -->
    <link href="https://brendan.ie/coffee/coffee.css" rel="stylesheet">
    <script src="https://brendan.ie/coffee/coffee.js"></script>
  </head>
  <body class="sticky-wrapper">
    <div id="coffee_anchor"><span id="served"></span></div>
    <script>C0FFEE()</script>

    <header>
      <h1>UL Room Finder  (Building)</h1>
    </header>
    <main id="anchor">
      <p>
        Like the main list, but broken down per building.
        <br />
        Green equals free.
        <br />
        Red line is an indication of teh current time.
        <br />
        <button onClick="run()" type="button">
          Refresh.
        </button>

      </p>
    </main>
    <footer>
      <span>
        <a href="https://gitlab.com/c2842/misc/ul_timetable_ical" rel='noopener noreferrer' target='_blank'>
          API source
        </a> | <wbr/>
        <a href="https://gitlab.com/brendan.ie/v1/-/blob/main/src/timetable/rooms_building.html" rel='noopener noreferrer' target='_blank'>
          Page source
        </a>
      </span>
      <br/>
      <span>
        © 2021-<span id="year">2021</span> | <wbr/>
        Brendan Golden | <wbr/>
        Email: contact_me(at symbol)brendan.ie <a href="mailto:contact_website@brendan.ie"></a><a href="mailto:contact@brendan.ie"></a>  | <wbr/>
        Gitlab: <a href="https://gitlab.com/Brendan_Golden">Brendan_Golden</a> | <wbr/>
        Discord: Silver#5563 | <wbr/>
        Mastodon: <a rel="me" href="https://mastodon.brendan.ie/@silver">@silver</a>
      </span>
    </footer>
    <script>
      /* I am a lazy fucker */
      document.getElementById('year').textContent = new Date().getFullYear().toString()
    </script>
    <script>
      run()

      async function run () {
        await fetch(`https://api.brendan.ie/timetable/rooms?hour=8`)
          // get the data
          .then((response) => {
            if (!response.ok) {
              console.error(`HTTP error! Status: ${response.status}`)
              return []
            }
            return response.json()
          })
          .then((data) => table_control(data))
          .catch((err) => console.log(err))
      }

      let buildings = [
        // CSIS first as thats the one I want to see first, rest alphabetical
        {code: "CS", building: "CSIS"},

        {code: "AD", building: "Analog"},
        {code: "ER", building: "Engineering Research"},
        {code: "GEMS", building: "School of Medicine"},
        {code: "GL", building: "Library"},
        {code: "HS", building: "Health Science"},
        {code: "IW", building: "Irish World Academy"},
        {code: "KB", building: "Kemmy Business School"},
        {code: "LC", building: "Languages"},
        {code: "SR", building: "Science and Education"},


        // single character so matched last
        // main building is a PITA
        {code: "A", building: "Main Building"},
        {code: "B", building: "Main Building"},
        {code: "C", building: "Main Building"},
        {code: "D", building: "Main Building"},
        {code: "E", building: "Main Building"},

        {code: "F", building: "Foundation"},
        {code: "L", building: "Lonsdale"},
        {code: "P", building: "PESS"},
        {code: "S", building: "Schuman"},
      ]

      function process_buildings(data) {
        let result = {};

        for (let i = 0; i < data.length; i++) {
          let entry = data[i];

          for (let j = 0; j < buildings.length; j++) {
            let building = buildings[j];
            if (entry["room"].startsWith(building.code)) {

              if (typeof result[building.code] === "undefined") {
                result[building.code] = {};
              }

              if (typeof result[building.code][entry["room"]] === "undefined") {
                result[building.code][entry["room"]] = [];
              }

              result[building.code][entry["room"]].push({
                building: building.building,
                start: entry["start"],
                end: entry["end"]
              });

              break;
            }
          }
        }

        return result
      }

      function table_control(data) {
        let processed = process_buildings(data);
        for (let building of buildings) {
          table_generate(building, data, processed)
        }
        update_pointers();
      }


      function table_generate (building, data, processed) {
        // remove existing table (if exists)
        table_delete(building.code)
        // create a new table
        let table = table_create(building.code)
        table_create_head(building, table, data)
        table_create_body(building, table, processed)
      }

      function table_delete (table_id) {
        let table = document.getElementById(table_id)
        if (!table) {
          return
        }
        table.remove()
      }

      function table_create (table_id) {
        const table = document.createElement('table')

        // from https://wiki.guildwars2.com/wiki/Day_and_night

        const pointer_time = document.createElement('span')
        pointer_time.classList.add(`event-pointer-time`)
        pointer_time.appendChild(document.createTextNode(`Now`))

        const pointer = document.createElement('div')
        pointer.classList.add(`event-pointer`)
        pointer.title = "Current Time"
        pointer.appendChild(pointer_time)

        const pointer_offset = document.createElement('div')
        pointer_offset.style = "height:25px; width:100%;";

        const div = document.createElement('div')
        div.id = table_id
        div.style = "position:relative";

        div.appendChild(pointer);
        div.appendChild(pointer_offset);

        div.appendChild(table)
        div.appendChild(document.createElement('br'))

        const anchor = document.getElementById('anchor')
        anchor.appendChild(div)

        return table
      }

      // thanks to https://www.valentinog.com/blog/html-table/ for some help
      function table_create_head (building, table, data) {
        let week_number = 1;
        let day_number = 0;
        if (data.length > 0) {
          week_number = data[0].week;
          day_number = data[0].day;
        }

        const headers = [
          'Room',
          '09:00',
          '10:00',
          '11:00',
          '12:00',
          '13:00',
          '14:00',
          '15:00',
          '16:00',
          '17:00',
        ]

        let thead = table.createTHead()
        let row_top = thead.insertRow()

        let place = document.createElement('th')
        place.appendChild(document.createTextNode(building.building))
        place.style = 'width: 100px'
        row_top.appendChild(place)

        let week = document.createElement('th')
        week.appendChild(document.createTextNode(`Week ${week_number} - ${week_number_to_text(day_number)}`))
        week.colSpan = headers.length - 1
        row_top.appendChild(week)

        // add the second row
        let row = thead.insertRow()
        for (let key of headers) {
          let th = document.createElement('th')
          let text = document.createTextNode(key)
          th.appendChild(text)
          row.appendChild(th)
        }
      }

      function week_number_to_text (n){
        switch (n){
          case 0 : return "Monday";
          case 1 : return "Tuesday";
          case 2 : return "Wednesday";
          case 3 : return "Thursday";
          case 4 : return "Friday";
          default : return "Not weekday";
        }
      }

      function table_create_body (building, table, data) {
        let data_sub = data[building.code];
        if (typeof data_sub === "undefined") {
          return;
        }
        let rooms = Object.keys(data_sub).sort();
        for (const room of rooms) {
          let times = data_sub[room];
          let row = table.insertRow()

          // room name
          let text = document.createTextNode(room)
          let cell = row.insertCell()
          cell.appendChild(text);

          let times_free = [0, 0, 0, 0, 0, 0, 0, 0, 0];
          for (const entry of times) {
            for (let i = (entry.start - 9); i < (entry.end - 9); i++) {
              times_free[i] = 1;
            }
          }

          for (const time of times_free) {
            let cell = row.insertCell();
            if (time === 1) {
              cell.style = 'background-color: green;'
            }
          }
        }
      }

      function update_pointers() {
        const pointers = document.getElementsByClassName("event-pointer");

        let now = new Date();
        let time = now.getHours() - 9;

        if (time < 0) {
          time = 0;
        } else if (time > 9) {
          time = 9
        } else {
          // get partial time, make it more granular
          time += now.getMinutes() / 60;
        }

        for (const pointer of pointers) {
          let table = pointer.nextElementSibling.nextElementSibling;
          let width_table = table.clientWidth;
          let width_first_col = table.firstElementChild.firstElementChild.firstElementChild.clientWidth;

          // get past teh first part
          let offset = width_first_col;

          let per_hour = ((width_table - width_first_col) / 9);
          offset += (per_hour * time)
          pointer.style = `position:absolute; left: ${offset}px;`
        }

        setTimeout(() => {update_pointers()}, 60000);
      }

    </script>
  </body>
</html>